

#include <stdio.h>
#include <fcntl.h>
#include <string.h>

#define ONEK (1024)
#define DEF_FILE_PERM (0600)
/* Default split file size. 6 splited files for 1.44MB diskettes */
/* and 5 splited files for 1.2MB diskettes */
#define BUF_SIZE (235)

#define NAME_BUF_SIZE (256)
char basename[NAME_BUF_SIZE], outname[NAME_BUF_SIZE];

main(argc, argv)
int argc;
char *argv[];
{
    int ifd, ofd;
    int read_len, write_len;
    int count;
    char *buf;
    int buf_size;

    buf_size = (argc >= 3) ? atoi(argv[2]) : BUF_SIZE;
    if (buf_size <= 0) {
        buf_size = BUF_SIZE;
    }
    buf_size *= ONEK;
    if ((buf = (char *) malloc(buf_size)) != NULL) {
        if (argc >= 2) {
            strcpy(basename, argv[1]);
            ifd = open(basename, O_RDONLY, 0);
            if (ifd >= 0) {
                count = 0;
                do {
                    read_len = read(ifd, buf, buf_size);
                    gen_append(count, basename, outname);
                    if ((ofd = creat(outname, DEF_FILE_PERM)) >= 0) {
                        write_len = write(ofd, buf, read_len);
                        close(ofd);
                        if (write_len < read_len) {
                            printf("Write error\n");
                        }
                        count++;
                    }
                    else {
                        printf("Open output file error\n");
                        read_len = -1;
                    }
                } while ((read_len == buf_size) && (count < 1000));
                if (count >= 1000) {
                    printf("Input file too large\n");
                }
                close(ifd);
            }
            else {
                printf("Input file %s open error\n", argv[1]);
            }
        }
        else {
            printf("Use: %s file-name [split-file-size-in-K]\n", argv[0]);
        }
    }
    else {
        printf("Can not allocate enough memory for file\n");
    }
}

gen_append(count, basename, outname)
int count;
char *basename, *outname;
{
    char c1, c0;
    char appendname[5];
    int count2;

    appendname[4] = '\0';
    appendname[3] = (count % 10) + '0';
    count /= 10;
    appendname[2] = (count % 10) + '0';
    count /= 10;
    appendname[1] = (count % 10) + '0';
    appendname[0] = '.';
    strcpy(outname, basename);
    strcat(outname, appendname);
}
